/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.166 Revision 1.401
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.166 2005/04/15 22:01:42 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.401 2012/08/20 19:45:57 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib 5# @ECLASS: eutils.eclass
13ECLASS=eutils 6# @MAINTAINER:
14INHERITED="$INHERITED $ECLASS" 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
15 17
16DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib toolchain-funcs user
17 22
18DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
19 24
20# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
21# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
22# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
23# must be an integer greater than zero. 28# @USAGE: [seconds]
24# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
25epause() { 34epause() {
26 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
27 sleep ${1:-5}
28 fi
29} 36}
30 37
31# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
32# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
33# don't beep. 40# @DESCRIPTION:
34# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
35ebeep() { 45ebeep() {
36 local n 46 local n
37 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
38 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
39 echo -ne "\a" 49 echo -ne "\a"
40 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
41 echo -ne "\a" 51 echo -ne "\a"
42 sleep 1 52 sleep 1
43 done 53 done
44 fi 54 fi
45} 55}
46 56
47# This function generate linker scripts in /usr/lib for dynamic 57else
48# libs in /lib. This is to fix linking problems when you have
49# the .so in /lib, and the .a in /usr/lib. What happens is that
50# in some cases when linking dynamic, the .a in /usr/lib is used
51# instead of the .so in /lib due to gcc/libtool tweaking ld's
52# library search path. This cause many builds to fail.
53# See bug #4411 for more info.
54#
55# To use, simply call:
56#
57# gen_usr_ldscript libfoo.so
58#
59# Note that you should in general use the unversioned name of
60# the library, as ldconfig should usually update it correctly
61# to point to the latest version of the library present.
62#
63# <azarah@gentoo.org> (26 Oct 2002)
64#
65gen_usr_ldscript() {
66 local libdir="$(get_libdir)"
67 # Just make sure it exists
68 dodir /usr/${libdir}
69 58
70 for lib in "${@}" ; do 59ebeep() {
71 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
72 /* GNU ld script 61}
73 Since Gentoo has critical dynamic libraries 62
74 in /lib, and the static versions in /usr/lib, 63epause() {
75 we need to have a "fake" dynamic lib in /usr/lib, 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
76 otherwise we run into linking problems. 65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
77 78 :
78 See bug http://bugs.gentoo.org/4411 for more info. 79 }
79 */ 80fi
80 GROUP ( /${libdir}/${lib} ) 81
81 END_LDSCRIPT 82# @FUNCTION: ecvs_clean
82 fperms a+x "/usr/${libdir}/${lib}" 83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
83 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
84} 121}
85 122
86# Simple function to draw a line consisting of '=' the same length as $* 123# @FUNCTION: estack_pop
87# - only to be used by epatch() 124# @USAGE: <stack> [variable]
88# 125# @DESCRIPTION:
89# <azarah@gentoo.org> (11 Nov 2002) 126# Pop a single item off the specified stack. If a variable is specified,
90# 127# the popped item is stored there. If no more items are available, return
91draw_line() { 128# 1, else return 0. See estack_push for more info.
92 local i=0 129estack_pop() {
93 local str_length="" 130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
94 131
95 # Handle calls that do not have args, or wc not being installed ... 132 # We use the fugly __estack_xxx var names to avoid collision with
96 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 133 # passing back the return value. If we used "local i" and the
97 then 134 # caller ran `estack_pop ... i`, we'd end up setting the local
98 echo "===============================================================" 135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
99 return 0 169# return 0
100 fi 170# fi
101
102 # Get the length of $*
103 str_length="$(echo -n "$*" | wc -m)"
104
105 while [ "$i" -lt "${str_length}" ]
106 do
107 echo -n "="
108
109 i=$((i + 1))
110 done 171# done
111 172# eshopts_pop
112 echo 173# @CODE
113 174eshopts_push() {
114 return 0 175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
115} 184}
116 185
117# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
118EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
119# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
120EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
121# Default options for patch 231# @VARIABLE: EPATCH_OPTS
122# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 232# @DESCRIPTION:
233# Options to pass to patch. Meant for ebuild/package-specific tweaking
234# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
235# for single patch tweaking, you can also pass flags directly to epatch.
123EPATCH_OPTS="-g0" 236EPATCH_OPTS=""
237# @VARIABLE: EPATCH_COMMON_OPTS
238# @DESCRIPTION:
239# Common options to pass to `patch`. You probably should never need to
240# change these. If you do, please discuss it with base-system first to
241# be sure.
242# @CODE
243# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
244# --no-backup-if-mismatch - do not leave .orig files behind
245# -E - automatically remove empty files
246# @CODE
247EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
248# @VARIABLE: EPATCH_EXCLUDE
249# @DESCRIPTION:
124# List of patches not to apply. Not this is only file names, 250# List of patches not to apply. Note this is only file names,
125# and not the full path .. 251# and not the full path. Globs accepted.
126EPATCH_EXCLUDE="" 252EPATCH_EXCLUDE=""
253# @VARIABLE: EPATCH_SINGLE_MSG
254# @DESCRIPTION:
127# Change the printed message for a single patch. 255# Change the printed message for a single patch.
128EPATCH_SINGLE_MSG="" 256EPATCH_SINGLE_MSG=""
129# Force applying bulk patches even if not following the style: 257# @VARIABLE: EPATCH_MULTI_MSG
130# 258# @DESCRIPTION:
131# ??_${ARCH}_foo.${EPATCH_SUFFIX} 259# Change the printed message for multiple patches.
132# 260EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
261# @VARIABLE: EPATCH_FORCE
262# @DESCRIPTION:
263# Only require patches to match EPATCH_SUFFIX rather than the extended
264# arch naming style.
133EPATCH_FORCE="no" 265EPATCH_FORCE="no"
134 266
135# This function is for bulk patching, or in theory for just one 267# @FUNCTION: epatch
136# or two patches. 268# @USAGE: [options] [patches] [dirs of patches]
269# @DESCRIPTION:
270# epatch is designed to greatly simplify the application of patches. It can
271# process patch files directly, or directories of patches. The patches may be
272# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
273# the -p option as epatch will automatically attempt -p0 to -p5 until things
274# apply successfully.
137# 275#
138# It should work with .bz2, .gz, .zip and plain text patches. 276# If you do not specify any patches/dirs, then epatch will default to the
139# Currently all patches should be the same format. 277# directory specified by EPATCH_SOURCE.
140# 278#
141# You do not have to specify '-p' option to patch, as it will 279# Any options specified that start with a dash will be passed down to patch
142# try with -p0 to -p5 until it succeed, or fail at -p5. 280# for this specific invocation. As soon as an arg w/out a dash is found, then
281# arg processing stops.
143# 282#
144# Above EPATCH_* variables can be used to control various defaults, 283# When processing directories, epatch will apply all patches that match:
145# bug they should be left as is to ensure an ebuild can rely on 284# @CODE
146# them for. 285# if ${EPATCH_FORCE} != "yes"
147#
148# Patches are applied in current directory.
149#
150# Bulk Patches should preferibly have the form of:
151#
152# ??_${ARCH}_foo.${EPATCH_SUFFIX} 286# ??_${ARCH}_foo.${EPATCH_SUFFIX}
287# else
288# *.${EPATCH_SUFFIX}
289# @CODE
290# The leading ?? are typically numbers used to force consistent patch ordering.
291# The arch field is used to apply patches only for the host architecture with
292# the special value of "all" means apply for everyone. Note that using values
293# other than "all" is highly discouraged -- you should apply patches all the
294# time and let architecture details be detected at configure/compile time.
153# 295#
154# For example: 296# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
297# for patches to apply.
155# 298#
156# 01_all_misc-fix.patch.bz2 299# Refer to the other EPATCH_xxx variables for more customization of behavior.
157# 02_sparc_another-fix.patch.bz2
158#
159# This ensures that there are a set order, and you can have ARCH
160# specific patches.
161#
162# If you however give an argument to epatch(), it will treat it as a
163# single patch that need to be applied if its a file. If on the other
164# hand its a directory, it will set EPATCH_SOURCE to this.
165#
166# <azarah@gentoo.org> (10 Nov 2002)
167#
168epatch() { 300epatch() {
169 local PIPE_CMD="" 301 _epatch_draw_line() {
170 local STDERR_TARGET="${T}/$$.out" 302 # create a line of same length as input string
171 local PATCH_TARGET="${T}/$$.patch" 303 [[ -z $1 ]] && set "$(printf "%65s" '')"
172 local PATCH_SUFFIX="" 304 echo "${1//?/=}"
173 local SINGLE_PATCH="no" 305 }
174 local x=""
175 306
176 if [ "$#" -gt 1 ] 307 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
177 then 308
309 # First process options. We localize the EPATCH_OPTS setting
310 # from above so that we can pass it on in the loop below with
311 # any additional values the user has specified.
312 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
313 while [[ $# -gt 0 ]] ; do
314 case $1 in
315 -*) EPATCH_OPTS+=( "$1" ) ;;
316 *) break ;;
317 esac
318 shift
319 done
320
321 # Let the rest of the code process one user arg at a time --
322 # each arg may expand into multiple patches, and each arg may
323 # need to start off with the default global EPATCH_xxx values
324 if [[ $# -gt 1 ]] ; then
178 local m="" 325 local m
179 einfo "${#} patches to apply ..."
180 for m in "$@" ; do 326 for m in "$@" ; do
181 epatch "${m}" 327 epatch "${m}"
182 done 328 done
183 return 0 329 return 0
184 fi 330 fi
185 331
186 if [ -n "$1" -a -f "$1" ] 332 local SINGLE_PATCH="no"
187 then 333 # no args means process ${EPATCH_SOURCE}
334 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
335
336 if [[ -f $1 ]] ; then
188 SINGLE_PATCH="yes" 337 SINGLE_PATCH="yes"
189 338 set -- "$1"
190 local EPATCH_SOURCE="$1" 339 # Use the suffix from the single patch (localize it); the code
340 # below will find the suffix for us
191 local EPATCH_SUFFIX="${1##*\.}" 341 local EPATCH_SUFFIX=$1
192 342
193 elif [ -n "$1" -a -d "$1" ] 343 elif [[ -d $1 ]] ; then
194 then 344 # Some people like to make dirs of patches w/out suffixes (vim)
195 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 345 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
196 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 346
347 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
348 # Re-use EPATCH_SOURCE as a search dir
349 epatch "${EPATCH_SOURCE}/$1"
350 return $?
351
352 else
353 # sanity check ... if it isn't a dir or file, wtf man ?
354 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
355 echo
356 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
357 eerror
358 eerror " ${EPATCH_SOURCE}"
359 eerror " ( ${EPATCH_SOURCE##*/} )"
360 echo
361 die "Cannot find \$EPATCH_SOURCE!"
362 fi
363
364 # Now that we know we're actually going to apply something, merge
365 # all of the patch options back in to a single variable for below.
366 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
367
368 local PIPE_CMD
369 case ${EPATCH_SUFFIX##*\.} in
370 xz) PIPE_CMD="xz -dc" ;;
371 lzma) PIPE_CMD="lzma -dc" ;;
372 bz2) PIPE_CMD="bzip2 -dc" ;;
373 gz|Z|z) PIPE_CMD="gzip -dc" ;;
374 ZIP|zip) PIPE_CMD="unzip -p" ;;
375 *) ;;
376 esac
377
378 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
379
380 local x
381 for x in "$@" ; do
382 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
383 # didn't match anything, ignore continue on
384 [[ ! -f ${x} ]] && continue
385
386 local patchname=${x##*/}
387
388 # Apply single patches, or forced sets of patches, or
389 # patches with ARCH dependant names.
390 # ???_arch_foo.patch
391 # Else, skip this input altogether
392 local a=${patchname#*_} # strip the ???_
393 a=${a%%_*} # strip the _foo.patch
394 if ! [[ ${SINGLE_PATCH} == "yes" || \
395 ${EPATCH_FORCE} == "yes" || \
396 ${a} == all || \
397 ${a} == ${ARCH} ]]
197 then 398 then
198 local EPATCH_SOURCE="$1/*" 399 continue
400 fi
401
402 # Let people filter things dynamically
403 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
404 # let people use globs in the exclude
405 eshopts_push -o noglob
406
407 local ex
408 for ex in ${EPATCH_EXCLUDE} ; do
409 if [[ ${patchname} == ${ex} ]] ; then
410 eshopts_pop
411 continue 2
412 fi
413 done
414
415 eshopts_pop
416 fi
417
418 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
419 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
420 einfo "${EPATCH_SINGLE_MSG}"
421 else
422 einfo "Applying ${patchname} ..."
423 fi
199 else 424 else
200 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 425 einfo " ${patchname} ..."
201 fi 426 fi
202 else 427
203 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 428 # most of the time, there will only be one run per unique name,
204 then 429 # but if there are more, make sure we get unique log filenames
205 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 430 local STDERR_TARGET="${T}/${patchname}.out"
206 then 431 if [[ -e ${STDERR_TARGET} ]] ; then
207 EPATCH_SOURCE="$1" 432 STDERR_TARGET="${T}/${patchname}-$$.out"
433 fi
434
435 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
436
437 # Decompress the patch if need be
438 local count=0
439 local PATCH_TARGET
440 if [[ -n ${PIPE_CMD} ]] ; then
441 PATCH_TARGET="${T}/$$.patch"
442 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
443
444 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
445 echo
446 eerror "Could not extract patch!"
447 #die "Could not extract patch!"
448 count=5
449 break
208 fi 450 fi
451 else
452 PATCH_TARGET=${x}
453 fi
209 454
455 # Check for absolute paths in patches. If sandbox is disabled,
456 # people could (accidently) patch files in the root filesystem.
457 # Or trigger other unpleasantries #237667. So disallow -p0 on
458 # such patches.
459 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
460 if [[ -n ${abs_paths} ]] ; then
461 count=1
462 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
463 fi
464 # Similar reason, but with relative paths.
465 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
466 if [[ -n ${rel_paths} ]] ; then
467 eqawarn "QA Notice: Your patch uses relative paths '../'."
468 eqawarn " In the future this will cause a failure."
469 eqawarn "${rel_paths}"
470 fi
471
472 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
473 local patch_cmd
474 while [[ ${count} -lt 5 ]] ; do
475 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
476
477 # Generate some useful debug info ...
478 (
479 _epatch_draw_line "***** ${patchname} *****"
210 echo 480 echo
211 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 481 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
482 echo
483 _epatch_draw_line "***** ${patchname} *****"
484 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
485 ret=$?
486 echo
487 echo "patch program exited with status ${ret}"
488 exit ${ret}
489 ) >> "${STDERR_TARGET}"
490
491 if [ $? -eq 0 ] ; then
492 (
493 _epatch_draw_line "***** ${patchname} *****"
494 echo
495 echo "ACTUALLY APPLYING ${patchname} ..."
496 echo
497 _epatch_draw_line "***** ${patchname} *****"
498 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
499 ret=$?
500 echo
501 echo "patch program exited with status ${ret}"
502 exit ${ret}
503 ) >> "${STDERR_TARGET}"
504
505 if [ $? -ne 0 ] ; then
506 echo
507 eerror "A dry-run of patch command succeeded, but actually"
508 eerror "applying the patch failed!"
509 #die "Real world sux compared to the dreamworld!"
510 count=5
511 fi
512 break
513 fi
514
515 : $(( count++ ))
516 done
517
518 # if we had to decompress the patch, delete the temp one
519 if [[ -n ${PIPE_CMD} ]] ; then
520 rm -f "${PATCH_TARGET}"
521 fi
522
523 if [[ ${count} -ge 5 ]] ; then
524 echo
525 eerror "Failed Patch: ${patchname} !"
526 eerror " ( ${PATCH_TARGET} )"
212 eerror 527 eerror
213 eerror " ${EPATCH_SOURCE}" 528 eerror "Include in your bugreport the contents of:"
214 eerror " ( ${EPATCH_SOURCE##*/} )" 529 eerror
530 eerror " ${STDERR_TARGET}"
215 echo 531 echo
216 die "Cannot find \$EPATCH_SOURCE!"
217 fi
218
219 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
220 fi
221
222 case ${EPATCH_SUFFIX##*\.} in
223 bz2)
224 PIPE_CMD="bzip2 -dc"
225 PATCH_SUFFIX="bz2"
226 ;;
227 gz|Z|z)
228 PIPE_CMD="gzip -dc"
229 PATCH_SUFFIX="gz"
230 ;;
231 ZIP|zip)
232 PIPE_CMD="unzip -p"
233 PATCH_SUFFIX="zip"
234 ;;
235 *)
236 PIPE_CMD="cat"
237 PATCH_SUFFIX="patch"
238 ;;
239 esac
240
241 if [ "${SINGLE_PATCH}" = "no" ]
242 then
243 einfo "Applying various patches (bugfixes/updates) ..."
244 fi
245 for x in ${EPATCH_SOURCE}
246 do
247 # New ARCH dependant patch naming scheme ...
248 #
249 # ???_arch_foo.patch
250 #
251 if [ -f ${x} ] && \
252 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
253 [ "${EPATCH_FORCE}" = "yes" ])
254 then
255 local count=0
256 local popts="${EPATCH_OPTS}"
257 local patchname=${x##*/}
258
259 if [ -n "${EPATCH_EXCLUDE}" ]
260 then
261 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
262 then
263 continue
264 fi
265 fi
266
267 if [ "${SINGLE_PATCH}" = "yes" ]
268 then
269 if [ -n "${EPATCH_SINGLE_MSG}" ]
270 then
271 einfo "${EPATCH_SINGLE_MSG}"
272 else
273 einfo "Applying ${patchname} ..."
274 fi
275 else
276 einfo " ${patchname} ..."
277 fi
278
279 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281
282 # Allow for prefix to differ ... im lazy, so shoot me :/
283 while [ "${count}" -lt 5 ]
284 do
285 # Generate some useful debug info ...
286 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
287 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
288
289 if [ "${PATCH_SUFFIX}" != "patch" ]
290 then
291 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
292 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
293 else
294 PATCH_TARGET="${x}"
295 fi
296
297 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
298 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
299
300 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302
303 if [ "${PATCH_SUFFIX}" != "patch" ]
304 then
305 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
306 then
307 echo
308 eerror "Could not extract patch!"
309 #die "Could not extract patch!"
310 count=5
311 break
312 fi
313 fi
314
315 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
316 then
317 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
318 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
320 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322
323 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
324
325 if [ "$?" -ne 0 ]
326 then
327 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
328 echo
329 eerror "A dry-run of patch command succeeded, but actually"
330 eerror "applying the patch failed!"
331 #die "Real world sux compared to the dreamworld!"
332 count=5
333 fi
334
335 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
336
337 break
338 fi
339
340 count=$((count + 1))
341 done
342
343 if [ "${PATCH_SUFFIX}" != "patch" ]
344 then
345 rm -f ${PATCH_TARGET}
346 fi
347
348 if [ "${count}" -eq 5 ]
349 then
350 echo
351 eerror "Failed Patch: ${patchname} !"
352 eerror " ( ${PATCH_TARGET} )"
353 eerror
354 eerror "Include in your bugreport the contents of:"
355 eerror
356 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
357 echo
358 die "Failed Patch: ${patchname}!" 532 die "Failed Patch: ${patchname}!"
359 fi 533 fi
360 534
361 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 535 # if everything worked, delete the full debug patch log
536 rm -f "${STDERR_TARGET}"
362 537
538 # then log away the exact stuff for people to review later
539 cat <<-EOF >> "${T}/epatch.log"
540 PATCH: ${x}
541 CMD: ${patch_cmd}
542 PWD: ${PWD}
543
544 EOF
363 eend 0 545 eend 0
364 fi
365 done 546 done
366 if [ "${SINGLE_PATCH}" = "no" ]
367 then
368 einfo "Done with patching"
369 fi
370}
371 547
372# This function return true if we are using the NPTL pthreads 548 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
373# implementation. 549 : # everything worked
374# 550}
375# <azarah@gentoo.org> (06 March 2003)
376#
377have_NPTL() {
378 cat > ${T}/test-nptl.c <<-"END"
379 #define _XOPEN_SOURCE
380 #include <unistd.h>
381 #include <stdio.h>
382 551
383 int main() 552# @FUNCTION: epatch_user
384 { 553# @USAGE:
385 char buf[255]; 554# @DESCRIPTION:
386 char *str = buf; 555# Applies user-provided patches to the source tree. The patches are
556# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
557# of these three directories to exist will be the one to use, ignoring
558# any more general directories which might exist as well. They must end
559# in ".patch" to be applied.
560#
561# User patches are intended for quick testing of patches without ebuild
562# modifications, as well as for permanent customizations a user might
563# desire. Obviously, there can be no official support for arbitrarily
564# patched ebuilds. So whenever a build log in a bug report mentions that
565# user patches were applied, the user should be asked to reproduce the
566# problem without these.
567#
568# Not all ebuilds do call this function, so placing patches in the
569# stated directory might or might not work, depending on the package and
570# the eclasses it inherits and uses. It is safe to call the function
571# repeatedly, so it is always possible to add a call at the ebuild
572# level. The first call is the time when the patches will be
573# applied.
574#
575# Ideally, this function should be called after gentoo-specific patches
576# have been applied, so that their code can be modified as well, but
577# before calls to e.g. eautoreconf, as the user patches might affect
578# autotool input files as well.
579epatch_user() {
580 [[ $# -ne 0 ]] && die "epatch_user takes no options"
387 581
388 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255); 582 # Allow multiple calls to this function; ignore all but the first
389 if (NULL != str) { 583 local applied="${T}/epatch_user.log"
390 printf("%s\n", str); 584 [[ -e ${applied} ]] && return 2
391 if (NULL != strstr(str, "NPTL"))
392 return 0;
393 }
394 585
395 return 1; 586 # don't clobber any EPATCH vars that the parent might want
396 } 587 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
397 END 588 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
398 589 EPATCH_SOURCE=${base}/${CTARGET}/${check}
399 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ..." 590 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
400 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null 591 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
401 then 592 if [[ -d ${EPATCH_SOURCE} ]] ; then
402 echo "yes" 593 EPATCH_SOURCE=${EPATCH_SOURCE} \
403 einfon "Checking what PTHREADS implementation we have ..." 594 EPATCH_SUFFIX="patch" \
404 if ${T}/nptl 595 EPATCH_FORCE="yes" \
405 then 596 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
597 epatch
598 echo "${EPATCH_SOURCE}" > "${applied}"
406 return 0 599 return 0
407 else
408 return 1
409 fi
410 else
411 echo "no"
412 fi 600 fi
413 601 done
602 echo "none" > "${applied}"
414 return 1 603 return 1
415} 604}
416 605
417# This function check how many cpu's are present, and then set 606# @FUNCTION: emktemp
418# -j in MAKEOPTS accordingly. 607# @USAGE: [temp dir]
419# 608# @DESCRIPTION:
420# Thanks to nall <nall@gentoo.org> for this.
421#
422get_number_of_jobs() {
423 local jobs=0
424
425 if [ ! -r /proc/cpuinfo ]
426 then
427 return 1
428 fi
429
430 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
431 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
432 then
433 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
434 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
435 ADMINPARAM="${ADMINPARAM/-j}"
436 fi
437
438 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
439
440 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
441 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
442 then
443 # these archs will always have "[Pp]rocessor"
444 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
445
446 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
447 then
448 # sparc always has "ncpus active"
449 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
450
451 elif [ "${ARCH}" = "alpha" ]
452 then
453 # alpha has "cpus active", but only when compiled with SMP
454 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
455 then
456 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
457 else
458 jobs=2
459 fi
460
461 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
462 then
463 # ppc has "processor", but only when compiled with SMP
464 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
465 then
466 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
467 else
468 jobs=2
469 fi
470 elif [ "${ARCH}" = "s390" ]
471 then
472 # s390 has "# processors : "
473 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
474 else
475 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
476 die "Unknown ARCH -- ${ARCH}!"
477 fi
478
479 # Make sure the number is valid ...
480 if [ "${jobs}" -lt 1 ]
481 then
482 jobs=1
483 fi
484
485 if [ -n "${ADMINPARAM}" ]
486 then
487 if [ "${jobs}" -gt "${ADMINPARAM}" ]
488 then
489 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge ..."
490 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
491 else
492 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge ..."
493 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
494 fi
495 fi
496}
497
498# Cheap replacement for when debianutils (and thus mktemp) 609# Cheap replacement for when debianutils (and thus mktemp)
499# does not exist on the users system 610# does not exist on the users system.
500# vapier@gentoo.org
501#
502# Takes just 1 optional parameter (the directory to create tmpfile in)
503emktemp() { 611emktemp() {
504 local exe="touch" 612 local exe="touch"
505 [ "$1" == "-d" ] && exe="mkdir" && shift 613 [[ $1 == -d ]] && exe="mkdir" && shift
506 local topdir="$1" 614 local topdir=$1
507 615
508 if [ -z "${topdir}" ] 616 if [[ -z ${topdir} ]] ; then
509 then
510 [ -z "${T}" ] \ 617 [[ -z ${T} ]] \
511 && topdir="/tmp" \ 618 && topdir="/tmp" \
512 || topdir="${T}" 619 || topdir=${T}
513 fi 620 fi
514 621
515 if [ -z "$(type -p mktemp)" ] 622 if ! type -P mktemp > /dev/null ; then
516 then 623 # system lacks `mktemp` so we have to fake it
517 local tmp=/ 624 local tmp=/
518 while [ -e "${tmp}" ] ; do 625 while [[ -e ${tmp} ]] ; do
519 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 626 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
520 done 627 done
521 ${exe} "${tmp}" 628 ${exe} "${tmp}" || ${exe} -p "${tmp}"
522 echo "${tmp}" 629 echo "${tmp}"
523 else 630 else
524 [ "${exe}" == "touch" ] \ 631 # the args here will give slightly wierd names on BSD,
525 && exe="-p" \ 632 # but should produce a usable file on all userlands
526 || exe="-d" 633 if [[ ${exe} == "touch" ]] ; then
527 mktemp ${exe} "${topdir}" 634 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
528 fi
529}
530
531# Small wrapper for getent (Linux), nidump (Mac OS X),
532# and pw (FreeBSD) used in enewuser()/enewgroup()
533# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
534# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
535#
536# egetent(database, key)
537egetent() {
538 if useq ppc-macos ; then
539 case "$2" in
540 *[!0-9]*) # Non numeric
541 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
542 ;;
543 *) # Numeric
544 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
545 ;;
546 esac
547 elif useq x86-fbsd ; then
548 local action
549 if [ "$1" == "passwd" ]
550 then
551 action="user"
552 else 635 else
553 action="group" 636 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
554 fi
555 pw show "${action}" "$2" -q
556 else
557 which nscd >& /dev/null && nscd -i "$1"
558 getent "$1" "$2"
559 fi
560}
561
562# Simplify/standardize adding users to the system
563# vapier@gentoo.org
564#
565# enewuser(username, uid, shell, homedir, groups, extra options)
566#
567# Default values if you do not specify any:
568# username: REQUIRED !
569# uid: next available (see useradd(8))
570# note: pass -1 to get default behavior
571# shell: /bin/false
572# homedir: /dev/null
573# groups: none
574# extra: comment of 'added by portage for ${PN}'
575enewuser() {
576 # get the username
577 local euser="$1"; shift
578 if [ -z "${euser}" ]
579 then
580 eerror "No username specified !"
581 die "Cannot call enewuser without a username"
582 fi
583
584 # lets see if the username already exists
585 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
586 then
587 return 0
588 fi
589 einfo "Adding user '${euser}' to your system ..."
590
591 # options to pass to useradd
592 local opts=
593
594 # handle uid
595 local euid="$1"; shift
596 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
597 then
598 if [ "${euid}" -gt 0 ]
599 then
600 if [ ! -z "`egetent passwd ${euid}`" ]
601 then
602 euid="next"
603 fi 637 fi
604 else
605 eerror "Userid given but is not greater than 0 !"
606 die "${euid} is not a valid UID"
607 fi 638 fi
608 else
609 euid="next"
610 fi
611 if [ "${euid}" == "next" ]
612 then
613 local pwrange
614 if [ "${USERLAND}" == "BSD" ] ; then
615 pwrange="`jot 898 101`"
616 else
617 pwrange="`seq 101 999`"
618 fi
619 for euid in ${pwrange} ; do
620 [ -z "`egetent passwd ${euid}`" ] && break
621 done
622 fi
623 opts="${opts} -u ${euid}"
624 einfo " - Userid: ${euid}"
625
626 # handle shell
627 local eshell="$1"; shift
628 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
629 then
630 if [ ! -e "${eshell}" ]
631 then
632 eerror "A shell was specified but it does not exist !"
633 die "${eshell} does not exist"
634 fi
635 else
636 if [ "${USERLAND}" == "BSD" ]
637 then
638 eshell="/usr/bin/false"
639 else
640 eshell="/bin/false"
641 fi
642 fi
643 einfo " - Shell: ${eshell}"
644 opts="${opts} -s ${eshell}"
645
646 # handle homedir
647 local ehome="$1"; shift
648 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
649 then
650 ehome="/dev/null"
651 fi
652 einfo " - Home: ${ehome}"
653 opts="${opts} -d ${ehome}"
654
655 # handle groups
656 local egroups="$1"; shift
657 if [ ! -z "${egroups}" ]
658 then
659 local oldifs="${IFS}"
660 local defgroup="" exgroups=""
661
662 export IFS=","
663 for g in ${egroups}
664 do
665 export IFS="${oldifs}"
666 if [ -z "`egetent group \"${g}\"`" ]
667 then
668 eerror "You must add group ${g} to the system first"
669 die "${g} is not a valid GID"
670 fi
671 if [ -z "${defgroup}" ]
672 then
673 defgroup="${g}"
674 else
675 exgroups="${exgroups},${g}"
676 fi
677 export IFS=","
678 done
679 export IFS="${oldifs}"
680
681 opts="${opts} -g ${defgroup}"
682 if [ ! -z "${exgroups}" ]
683 then
684 opts="${opts} -G ${exgroups:1}"
685 fi
686 else
687 egroups="(none)"
688 fi
689 einfo " - Groups: ${egroups}"
690
691 # handle extra and add the user
692 local eextra="$@"
693 local oldsandbox="${SANDBOX_ON}"
694 export SANDBOX_ON="0"
695 if useq ppc-macos
696 then
697 ### Make the user
698 if [ -z "${eextra}" ]
699 then
700 dscl . create /users/${euser} uid ${euid}
701 dscl . create /users/${euser} shell ${eshell}
702 dscl . create /users/${euser} home ${ehome}
703 dscl . create /users/${euser} realname "added by portage for ${PN}"
704 ### Add the user to the groups specified
705 local oldifs="${IFS}"
706 export IFS=","
707 for g in ${egroups}
708 do
709 dscl . merge /groups/${g} users ${euser}
710 done
711 export IFS="${oldifs}"
712 else
713 einfo "Extra options are not supported on macos yet"
714 einfo "Please report the ebuild along with the info below"
715 einfo "eextra: ${eextra}"
716 die "Required function missing"
717 fi
718 elif use x86-fbsd ; then
719 if [ -z "${eextra}" ]
720 then
721 pw useradd ${euser} ${opts} \
722 -c "added by portage for ${PN}" \
723 die "enewuser failed"
724 else
725 einfo " - Extra: ${eextra}"
726 pw useradd ${euser} ${opts} \
727 -c ${eextra} || die "enewuser failed"
728 fi
729 else
730 if [ -z "${eextra}" ]
731 then
732 useradd ${opts} ${euser} \
733 -c "added by portage for ${PN}" \
734 || die "enewuser failed"
735 else
736 einfo " - Extra: ${eextra}"
737 useradd ${opts} ${euser} ${eextra} \
738 || die "enewuser failed"
739 fi
740 fi
741 export SANDBOX_ON="${oldsandbox}"
742
743 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
744 then
745 einfo " - Creating ${ehome} in ${D}"
746 dodir ${ehome}
747 fowners ${euser} ${ehome}
748 fperms 755 ${ehome}
749 fi
750} 639}
751 640
752# Simplify/standardize adding groups to the system 641# @FUNCTION: edos2unix
753# vapier@gentoo.org 642# @USAGE: <file> [more files ...]
754# 643# @DESCRIPTION:
755# enewgroup(group, gid) 644# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
756# 645# to remove all of these text utilities from DEPEND variables because this
757# Default values if you do not specify any: 646# is a script based solution. Just give it a list of files to convert and
758# groupname: REQUIRED ! 647# they will all be changed from the DOS CRLF format to the UNIX LF format.
759# gid: next available (see groupadd(8))
760# extra: none
761enewgroup() {
762 # get the group
763 local egroup="$1"; shift
764 if [ -z "${egroup}" ]
765 then
766 eerror "No group specified !"
767 die "Cannot call enewgroup without a group"
768 fi
769
770 # see if group already exists
771 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
772 then
773 return 0
774 fi
775 einfo "Adding group '${egroup}' to your system ..."
776
777 # options to pass to useradd
778 local opts=
779
780 # handle gid
781 local egid="$1"; shift
782 if [ ! -z "${egid}" ]
783 then
784 if [ "${egid}" -gt 0 ]
785 then
786 if [ -z "`egetent group ${egid}`" ]
787 then
788 if useq ppc-macos ; then
789 opts="${opts} ${egid}"
790 else
791 opts="${opts} -g ${egid}"
792 fi
793 else
794 egid="next available; requested gid taken"
795 fi
796 else
797 eerror "Groupid given but is not greater than 0 !"
798 die "${egid} is not a valid GID"
799 fi
800 else
801 egid="next available"
802 fi
803 einfo " - Groupid: ${egid}"
804
805 # handle extra
806 local eextra="$@"
807 opts="${opts} ${eextra}"
808
809 # add the group
810 local oldsandbox="${SANDBOX_ON}"
811 export SANDBOX_ON="0"
812 if useq ppc-macos ; then
813 if [ ! -z "${eextra}" ];
814 then
815 einfo "Extra options are not supported on macos yet"
816 einfo "Please report the ebuild along with the info below"
817 einfo "eextra: ${eextra}"
818 die "Required function missing"
819 fi
820
821 # If we need the next available
822 case ${egid} in
823 *[!0-9]*) # Non numeric
824 for egid in `jot 898 101`; do
825 [ -z "`egetent group ${egid}`" ] && break
826 done
827 esac
828 dscl . create /groups/${egroup} gid ${egid}
829 dscl . create /groups/${egroup} passwd '*'
830 elif use x86-fbsd ; then
831 case ${egid} in
832 *[!0-9]*) # Non numeric
833 for egid in `jot 898 101`; do
834 [ -z "`egetent group ${egid}`" ] && break
835 done
836 esac
837 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
838 else
839 groupadd ${opts} ${egroup} || die "enewgroup failed"
840 fi
841 export SANDBOX_ON="${oldsandbox}"
842}
843
844# Simple script to replace 'dos2unix' binaries
845# vapier@gentoo.org
846#
847# edos2unix(file, <more files> ...)
848edos2unix() { 648edos2unix() {
849 for f in "$@" 649 [[ $# -eq 0 ]] && return 0
850 do 650 sed -i 's/\r$//' -- "$@" || die
851 cp "${f}" ${T}/edos2unix
852 sed 's/\r$//' ${T}/edos2unix > "${f}"
853 done
854} 651}
855 652
856 653# @FUNCTION: make_desktop_entry
857############################################################## 654# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
858# START: Handle .desktop files and menu entries # 655# @DESCRIPTION:
859# maybe this should be separated into a new eclass some time #
860# lanius@gentoo.org #
861##############################################################
862
863# Make a desktop file ! 656# Make a .desktop file.
864# Great for making those icons in kde/gnome startmenu !
865# Amaze your friends ! Get the women ! Join today !
866# 657#
867# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 658# @CODE
868#
869# binary: what binary does the app run with ? 659# binary: what command does the app run with ?
870# name: the name that will show up in the menu 660# name: the name that will show up in the menu
871# icon: give your little like a pretty little icon ... 661# icon: the icon to use in the menu entry
872# this can be relative (to /usr/share/pixmaps) or 662# this can be relative (to /usr/share/pixmaps) or
873# a full path to an icon 663# a full path to an icon
874# type: what kind of application is this ? for categories: 664# type: what kind of application is this?
875# http://www.freedesktop.org/wiki/Standards_2fmenu_2dspec 665# for categories:
876# path: if your app needs to startup in a specific dir 666# http://standards.freedesktop.org/menu-spec/latest/apa.html
667# if unset, function tries to guess from package's category
668# fields: extra fields to append to the desktop file; a printf string
669# @CODE
877make_desktop_entry() { 670make_desktop_entry() {
878 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 671 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
879 672
880 local exec=${1} 673 local exec=${1}
881 local name=${2:-${PN}} 674 local name=${2:-${PN}}
882 local icon=${3:-${PN}.png} 675 local icon=${3:-${PN}}
883 local type=${4} 676 local type=${4}
884 local path=${5} 677 local fields=${5}
885 678
886 if [[ -z ${type} ]] ; then 679 if [[ -z ${type} ]] ; then
887 local catmaj=${CATEGORY%%-*} 680 local catmaj=${CATEGORY%%-*}
888 local catmin=${CATEGORY##*-} 681 local catmin=${CATEGORY##*-}
889 case ${catmaj} in 682 case ${catmaj} in
890 app) 683 app)
891 case ${catmin} in 684 case ${catmin} in
685 accessibility) type="Utility;Accessibility";;
892 admin) type=System;; 686 admin) type=System;;
687 antivirus) type=System;;
688 arch) type="Utility;Archiving";;
689 backup) type="Utility;Archiving";;
893 cdr) type=DiscBurning;; 690 cdr) type="AudioVideo;DiscBurning";;
894 dicts) type=Dictionary;; 691 dicts) type="Office;Dictionary";;
692 doc) type=Documentation;;
895 editors) type=TextEditor;; 693 editors) type="Utility;TextEditor";;
896 emacs) type=TextEditor;; 694 emacs) type="Development;TextEditor";;
897 emulation) type=Emulator;; 695 emulation) type="System;Emulator";;
898 laptop) type=HardwareSettings;; 696 laptop) type="Settings;HardwareSettings";;
899 office) type=Office;; 697 office) type=Office;;
698 pda) type="Office;PDA";;
900 vim) type=TextEditor;; 699 vim) type="Development;TextEditor";;
901 xemacs) type=TextEditor;; 700 xemacs) type="Development;TextEditor";;
902 *) type=;;
903 esac 701 esac
904 ;; 702 ;;
905 703
906 dev) 704 dev)
907 type="Development" 705 type="Development"
908 ;; 706 ;;
909 707
910 games) 708 games)
911 [[ -z ${path} ]] && path=${GAMES_BINDIR}
912
913 case ${catmin} in 709 case ${catmin} in
914 action) type=ActionGame;; 710 action|fps) type=ActionGame;;
915 arcade) type=ArcadeGame;; 711 arcade) type=ArcadeGame;;
916 board) type=BoardGame;; 712 board) type=BoardGame;;
917 kid) type=KidsGame;;
918 emulation) type=Emulator;; 713 emulation) type=Emulator;;
714 kids) type=KidsGame;;
919 puzzle) type=LogicGame;; 715 puzzle) type=LogicGame;;
716 roguelike) type=RolePlaying;;
920 rpg) type=RolePlaying;; 717 rpg) type=RolePlaying;;
921 roguelike) type=RolePlaying;;
922 simulation) type=Simulation;; 718 simulation) type=Simulation;;
923 sports) type=SportsGame;; 719 sports) type=SportsGame;;
924 strategy) type=StrategyGame;; 720 strategy) type=StrategyGame;;
925 *) type=;;
926 esac 721 esac
927 type="Game;${type}" 722 type="Game;${type}"
928 ;; 723 ;;
929 724
725 gnome)
726 type="Gnome;GTK"
727 ;;
728
729 kde)
730 type="KDE;Qt"
731 ;;
732
930 mail) 733 mail)
931 type="Network;Email" 734 type="Network;Email"
932 ;; 735 ;;
933 736
934 media) 737 media)
935 case ${catmin} in 738 case ${catmin} in
739 gfx)
936 gfx) type=Graphics;; 740 type=Graphics
741 ;;
742 *)
743 case ${catmin} in
937 radio) type=Tuner;; 744 radio) type=Tuner;;
938 sound) type=Audio;; 745 sound) type=Audio;;
939 tv) type=TV;; 746 tv) type=TV;;
940 video) type=Video;; 747 video) type=Video;;
941 *) type=;; 748 esac
749 type="AudioVideo;${type}"
750 ;;
942 esac 751 esac
943 type="AudioVideo;${type}"
944 ;; 752 ;;
945 753
946 net) 754 net)
947 case ${catmin} in 755 case ${catmin} in
948 dialup) type=Dialup;; 756 dialup) type=Dialup;;
951 irc) type=IRCClient;; 759 irc) type=IRCClient;;
952 mail) type=Email;; 760 mail) type=Email;;
953 news) type=News;; 761 news) type=News;;
954 nntp) type=News;; 762 nntp) type=News;;
955 p2p) type=FileTransfer;; 763 p2p) type=FileTransfer;;
956 *) type=;; 764 voip) type=Telephony;;
957 esac 765 esac
958 type="Network;${type}" 766 type="Network;${type}"
959 ;; 767 ;;
960 768
961 sci) 769 sci)
962 case ${catmin} in 770 case ${catmin} in
963 astro*) type=Astronomoy;; 771 astro*) type=Astronomy;;
964 bio*) type=Biology;; 772 bio*) type=Biology;;
965 calc*) type=Calculator;; 773 calc*) type=Calculator;;
966 chem*) type=Chemistry;; 774 chem*) type=Chemistry;;
775 elec*) type=Electronics;;
967 geo*) type=Geology;; 776 geo*) type=Geology;;
968 math*) type=Math;; 777 math*) type=Math;;
969 *) type=;; 778 physics) type=Physics;;
779 visual*) type=DataVisualization;;
970 esac 780 esac
971 type="Science;${type}" 781 type="Education;Science;${type}"
782 ;;
783
784 sys)
785 type="System"
972 ;; 786 ;;
973 787
974 www) 788 www)
975 case ${catmin} in 789 case ${catmin} in
976 client) type=WebBrowser;; 790 client) type=WebBrowser;;
977 *) type=;;
978 esac 791 esac
979 type="Network" 792 type="Network;${type}"
980 ;; 793 ;;
981 794
982 *) 795 *)
983 type= 796 type=
984 ;; 797 ;;
985 esac 798 esac
986 fi 799 fi
987 800 if [ "${SLOT}" == "0" ] ; then
801 local desktop_name="${PN}"
802 else
803 local desktop_name="${PN}-${SLOT}"
804 fi
805 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
988 local desktop=${T}/${exec%% *}-${P}.desktop 806 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
989 807
808 # Don't append another ";" when a valid category value is provided.
809 type=${type%;}${type:+;}
810
811 eshopts_push -s extglob
812 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
813 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
814 ewarn "allowed in .desktop files if the value is not an absolute path."
815 icon=${icon%.@(xpm|png|svg)}
816 fi
817 eshopts_pop
818
819 cat <<-EOF > "${desktop}"
990echo "[Desktop Entry] 820 [Desktop Entry]
991Encoding=UTF-8
992Version=0.9.2
993Name=${name} 821 Name=${name}
994Type=Application 822 Type=Application
995Comment=${DESCRIPTION} 823 Comment=${DESCRIPTION}
996Exec=${exec} 824 Exec=${exec}
997Path=${path} 825 TryExec=${exec%% *}
998Icon=${icon} 826 Icon=${icon}
999Categories=Application;${type};" > "${desktop}" 827 Categories=${type}
828 EOF
1000 829
830 if [[ ${fields:-=} != *=* ]] ; then
831 # 5th arg used to be value to Path=
832 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
833 fields="Path=${fields}"
834 fi
835 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
836
837 (
838 # wrap the env here so that the 'insinto' call
839 # doesn't corrupt the env of the caller
1001 insinto /usr/share/applications 840 insinto /usr/share/applications
1002 doins "${desktop}" 841 doins "${desktop}"
1003 842 ) || die "installing desktop file failed"
1004 return 0
1005} 843}
1006 844
1007# Make a GDM/KDM Session file 845# @FUNCTION: validate_desktop_entries
1008# 846# @USAGE: [directories]
1009# make_desktop_entry(<title>, <command>) 847# @MAINTAINER:
1010# title: File to execute to start the Window Manager 848# Carsten Lohrke <carlo@gentoo.org>
1011# command: Name of the Window Manager 849# @DESCRIPTION:
850# Validate desktop entries using desktop-file-utils
851validate_desktop_entries() {
852 if [[ -x /usr/bin/desktop-file-validate ]] ; then
853 einfo "Checking desktop entry validity"
854 local directories=""
855 for d in /usr/share/applications $@ ; do
856 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
857 done
858 if [[ -n ${directories} ]] ; then
859 for FILE in $(find ${directories} -name "*\.desktop" \
860 -not -path '*.hidden*' | sort -u 2>/dev/null)
861 do
862 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
863 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
864 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
865 done
866 fi
867 echo ""
868 else
869 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
870 fi
871}
1012 872
873# @FUNCTION: make_session_desktop
874# @USAGE: <title> <command> [command args...]
875# @DESCRIPTION:
876# Make a GDM/KDM Session file. The title is the file to execute to start the
877# Window Manager. The command is the name of the Window Manager.
878#
879# You can set the name of the file via the ${wm} variable.
1013make_session_desktop() { 880make_session_desktop() {
1014
1015 [ -z "$1" ] && eerror "make_session_desktop: You must specify the title" && return 1 881 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1016 [ -z "$2" ] && eerror "make_session_desktop: You must specify the command" && return 1 882 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1017 883
1018 local title="${1}" 884 local title=$1
1019 local command="${2}" 885 local command=$2
1020 local desktop="${T}/${wm}.desktop" 886 local desktop=${T}/${wm:-${PN}}.desktop
887 shift 2
1021 888
889 cat <<-EOF > "${desktop}"
1022echo "[Desktop Entry] 890 [Desktop Entry]
1023Encoding=UTF-8
1024Name=${title} 891 Name=${title}
1025Comment=This session logs you into ${title} 892 Comment=This session logs you into ${title}
1026Exec=${command} 893 Exec=${command} $*
1027TryExec=${command} 894 TryExec=${command}
1028Type=Application" > "${desktop}" 895 Type=XSession
896 EOF
1029 897
898 (
899 # wrap the env here so that the 'insinto' call
900 # doesn't corrupt the env of the caller
1030 insinto /usr/share/xsessions 901 insinto /usr/share/xsessions
1031 doins "${desktop}" 902 doins "${desktop}"
1032 903 )
1033 return 0
1034} 904}
1035 905
906# @FUNCTION: domenu
907# @USAGE: <menus>
908# @DESCRIPTION:
909# Install the list of .desktop menu files into the appropriate directory
910# (/usr/share/applications).
1036domenu() { 911domenu() {
1037 local i 912 (
1038 local j 913 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller
915 local i j ret=0
1039 insinto /usr/share/applications 916 insinto /usr/share/applications
1040 for i in ${@} 917 for i in "$@" ; do
1041 do
1042 if [ -f "${i}" ]; 918 if [[ -f ${i} ]] ; then
1043 then
1044 doins ${i} 919 doins "${i}"
920 ((ret+=$?))
1045 elif [ -d "${i}" ]; 921 elif [[ -d ${i} ]] ; then
1046 then
1047 for j in ${i}/*.desktop 922 for j in "${i}"/*.desktop ; do
1048 do
1049 doins ${j} 923 doins "${j}"
924 ((ret+=$?))
1050 done 925 done
926 else
927 ((++ret))
1051 fi 928 fi
1052 done 929 done
930 exit ${ret}
931 )
1053} 932}
1054 933
1055doicon() { 934# @FUNCTION: newmenu
1056 local i 935# @USAGE: <menu> <newname>
1057 local j 936# @DESCRIPTION:
937# Like all other new* functions, install the specified menu as newname.
938newmenu() {
939 (
940 # wrap the env here so that the 'insinto' call
941 # doesn't corrupt the env of the caller
1058 insinto /usr/share/pixmaps 942 insinto /usr/share/applications
1059 for i in ${@} 943 newins "$@"
1060 do 944 )
1061 if [ -f "${i}" ];
1062 then
1063 doins ${i}
1064 elif [ -d "${i}" ];
1065 then
1066 for j in ${i}/*.png
1067 do
1068 doins ${j}
1069 done
1070 fi
1071 done
1072} 945}
1073 946
1074############################################################## 947# @FUNCTION: _iconins
1075# END: Handle .desktop files and menu entries # 948# @INTERNAL
1076############################################################## 949# @DESCRIPTION:
950# function for use in doicon and newicon
951_iconins() {
952 (
953 # wrap the env here so that the 'insinto' call
954 # doesn't corrupt the env of the caller
955 local funcname=$1; shift
956 local size dir
957 local context=apps
958 local theme=hicolor
1077 959
1078 960 while [[ $# -gt 0 ]] ; do
1079# for internal use only (unpack_pdv and unpack_makeself) 961 case $1 in
1080find_unpackable_file() { 962 -s|--size)
1081 local src="$1" 963 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1082 if [ -z "${src}" ] 964 size=${2%%x*}
1083 then
1084 src="${DISTDIR}/${A}"
1085 else
1086 if [ -e "${DISTDIR}/${src}" ]
1087 then
1088 src="${DISTDIR}/${src}"
1089 elif [ -e "${PWD}/${src}" ]
1090 then
1091 src="${PWD}/${src}"
1092 elif [ -e "${src}" ]
1093 then
1094 src="${src}"
1095 fi
1096 fi
1097 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
1098 echo "${src}"
1099}
1100
1101# Unpack those pesky pdv generated files ...
1102# They're self-unpacking programs with the binary package stuffed in
1103# the middle of the archive. Valve seems to use it a lot ... too bad
1104# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1105#
1106# Usage: unpack_pdv [file to unpack] [size of off_t]
1107# - you have to specify the off_t size ... i have no idea how to extract that
1108# information out of the binary executable myself. basically you pass in
1109# the size of the off_t type (in bytes) on the machine that built the pdv
1110# archive. one way to determine this is by running the following commands:
1111# strings <pdv archive> | grep lseek
1112# strace -elseek <pdv archive>
1113# basically look for the first lseek command (we do the strings/grep because
1114# sometimes the function call is _llseek or something) and steal the 2nd
1115# parameter. here is an example:
1116# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1117# lseek
1118# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1119# lseek(3, -4, SEEK_END) = 2981250
1120# thus we would pass in the value of '4' as the second parameter.
1121unpack_pdv() {
1122 local src="`find_unpackable_file $1`"
1123 local sizeoff_t="$2"
1124
1125 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
1126
1127 local shrtsrc="`basename ${src}`"
1128 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1129 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1130 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1131
1132 # grab metadata for debug reasons
1133 local metafile="$(emktemp)"
1134 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1135
1136 # rip out the final file name from the metadata
1137 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1138 datafile="`basename ${datafile}`"
1139
1140 # now lets uncompress/untar the file if need be
1141 local tmpfile="$(emktemp)"
1142 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1143
1144 local iscompressed="`file -b ${tmpfile}`"
1145 if [ "${iscompressed:0:8}" == "compress" ] ; then
1146 iscompressed=1
1147 mv ${tmpfile}{,.Z}
1148 gunzip ${tmpfile}
1149 else
1150 iscompressed=0
1151 fi
1152 local istar="`file -b ${tmpfile}`"
1153 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1154 istar=1
1155 else
1156 istar=0
1157 fi
1158
1159 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1160 #dd if=${src} ibs=${metaskip} count=1 \
1161 # | dd ibs=${tailskip} skip=1 \
1162 # | gzip -dc \
1163 # > ${datafile}
1164 if [ ${iscompressed} -eq 1 ] ; then
1165 if [ ${istar} -eq 1 ] ; then
1166 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1167 | head -c $((${metaskip}-${tailskip})) \
1168 | tar -xzf -
1169 else 965 else
1170 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \ 966 size=${2}
1171 | head -c $((${metaskip}-${tailskip})) \
1172 | gzip -dc \
1173 > ${datafile}
1174 fi 967 fi
1175 else
1176 if [ ${istar} -eq 1 ] ; then
1177 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1178 | head -c $((${metaskip}-${tailskip})) \
1179 | tar --no-same-owner -xf -
1180 else
1181 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1182 | head -c $((${metaskip}-${tailskip})) \
1183 > ${datafile}
1184 fi
1185 fi
1186 true
1187 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1188 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1189}
1190
1191# Unpack those pesky makeself generated files ...
1192# They're shell scripts with the binary package tagged onto
1193# the end of the archive. Loki utilized the format as does
1194# many other game companies.
1195#
1196# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1197# - If the file is not specified then unpack will utilize ${A}.
1198# - If the offset is not specified then we will attempt to extract
1199# the proper offset from the script itself.
1200unpack_makeself() {
1201 local src="$(find_unpackable_file "$1")"
1202 local skip="$2"
1203 local exe="$3"
1204
1205 local shrtsrc="$(basename "${src}")"
1206 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1207 if [ -z "${skip}" ]
1208 then
1209 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1210 local skip=0
1211 exe=tail
1212 case ${ver} in 968 case ${size} in
1213 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 969 16|22|24|32|36|48|64|72|96|128|192|256)
1214 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 970 size=${size}x${size};;
1215 ;; 971 scalable)
1216 2.0|2.0.1)
1217 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1218 ;;
1219 2.1.1)
1220 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1221 let skip="skip + 1"
1222 ;;
1223 2.1.2)
1224 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1225 let skip="skip + 1"
1226 ;;
1227 2.1.3)
1228 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1229 let skip="skip + 1"
1230 ;;
1231 2.1.4)
1232 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1233 skip=$(head -n ${skip} "${src}" | wc -c)
1234 exe="dd"
1235 ;; 972 ;;
1236 *) 973 *)
1237 eerror "I'm sorry, but I was unable to support the Makeself file." 974 eerror "${size} is an unsupported icon size!"
1238 eerror "The version I detected was '${ver}'." 975 exit 1;;
1239 eerror "Please file a bug about the file ${shrtsrc} at" 976 esac
1240 eerror "http://bugs.gentoo.org/ so that support can be added." 977 shift 2;;
1241 die "makeself version '${ver}' not supported" 978 -t|--theme)
1242 ;; 979 theme=${2}
980 shift 2;;
981 -c|--context)
982 context=${2}
983 shift 2;;
984 *)
985 if [[ -z ${size} ]] ; then
986 insinto /usr/share/pixmaps
987 else
988 insinto /usr/share/icons/${theme}/${size}/${context}
989 fi
990
991 if [[ ${funcname} == doicon ]] ; then
992 if [[ -f $1 ]] ; then
993 doins "${1}"
994 elif [[ -d $1 ]] ; then
995 shopt -s nullglob
996 doins "${1}"/*.{png,svg}
997 shopt -u nullglob
998 else
999 eerror "${1} is not a valid file/directory!"
1000 exit 1
1001 fi
1002 else
1003 break
1004 fi
1005 shift 1;;
1243 esac 1006 esac
1244 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1245 fi
1246 case ${exe} in
1247 tail) exe="tail -n +${skip} '${src}'";;
1248 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1249 *) die "makeself cant handle exe '${exe}'"
1250 esac
1251
1252 # lets grab the first few bytes of the file to figure out what kind of archive it is
1253 local tmpfile="$(emktemp)"
1254 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1255 local filetype="$(file -b "${tmpfile}")"
1256 case ${filetype} in
1257 *tar\ archive)
1258 eval ${exe} | tar --no-same-owner -xf -
1259 ;;
1260 bzip2*)
1261 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1262 ;;
1263 gzip*)
1264 eval ${exe} | tar --no-same-owner -xzf -
1265 ;;
1266 compress*)
1267 eval ${exe} | gunzip | tar --no-same-owner -xf -
1268 ;;
1269 *)
1270 eerror "Unknown filetype \"${filetype}\" ?"
1271 false
1272 ;;
1273 esac
1274 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1275}
1276
1277# Display a license for user to accept.
1278#
1279# Usage: check_license [license]
1280# - If the file is not specified then ${LICENSE} is used.
1281check_license() {
1282 local lic=$1
1283 if [ -z "${lic}" ] ; then
1284 lic="${PORTDIR}/licenses/${LICENSE}"
1285 else
1286 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1287 lic="${PORTDIR}/licenses/${src}"
1288 elif [ -e "${PWD}/${src}" ] ; then
1289 lic="${PWD}/${src}"
1290 elif [ -e "${src}" ] ; then
1291 lic="${src}"
1292 fi
1293 fi
1294 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1295 local l="`basename ${lic}`"
1296
1297 # here is where we check for the licenses the user already
1298 # accepted ... if we don't find a match, we make the user accept
1299 local shopts=$-
1300 local alic
1301 set -o noglob #so that bash doesn't expand "*"
1302 for alic in ${ACCEPT_LICENSE} ; do
1303 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1304 set +o noglob; set -${shopts} #reset old shell opts
1305 return 0
1306 fi
1307 done 1007 done
1308 set +o noglob; set -$shopts #reset old shell opts 1008 if [[ ${funcname} == newicon ]] ; then
1309 1009 newins "$@"
1310 local licmsg="$(emktemp)"
1311 cat << EOF > ${licmsg}
1312**********************************************************
1313The following license outlines the terms of use of this
1314package. You MUST accept this license for installation to
1315continue. When you are done viewing, hit 'q'. If you
1316CTRL+C out of this, the install will not run!
1317**********************************************************
1318
1319EOF
1320 cat ${lic} >> ${licmsg}
1321 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1322 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1323 read alic
1324 case ${alic} in
1325 yes|Yes|y|Y)
1326 return 0
1327 ;;
1328 *)
1329 echo;echo;echo
1330 eerror "You MUST accept the license to continue! Exiting!"
1331 die "Failed to accept license"
1332 ;;
1333 esac
1334}
1335
1336# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1337# the whole 'non-interactive' policy, but damnit I want CD support !
1338#
1339# with these cdrom functions we handle all the user interaction and
1340# standardize everything. all you have to do is call cdrom_get_cds()
1341# and when the function returns, you can assume that the cd has been
1342# found at CDROM_ROOT.
1343#
1344# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1345# etc... if you want to give the cds better names, then just export
1346# the CDROM_NAME_X variables before calling cdrom_get_cds().
1347#
1348# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1349#
1350# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1351# - this will attempt to locate a cd based upon a file that is on
1352# the cd ... the more files you give this function, the more cds
1353# the cdrom functions will handle
1354cdrom_get_cds() {
1355 # first we figure out how many cds we're dealing with by
1356 # the # of files they gave us
1357 local cdcnt=0
1358 local f=
1359 for f in "$@" ; do
1360 cdcnt=$((cdcnt + 1))
1361 export CDROM_CHECK_${cdcnt}="$f"
1362 done
1363 export CDROM_TOTAL_CDS=${cdcnt}
1364 export CDROM_CURRENT_CD=1
1365
1366 # now we see if the user gave use CD_ROOT ...
1367 # if they did, let's just believe them that it's correct
1368 if [[ ! -z ${CD_ROOT} ]] ; then
1369 export CDROM_ROOT=${CD_ROOT}
1370 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1371 return
1372 fi
1373 # do the same for CD_ROOT_X
1374 if [[ ! -z ${CD_ROOT_1} ]] ; then
1375 local var=
1376 cdcnt=0
1377 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1378 cdcnt=$((cdcnt + 1))
1379 var="CD_ROOT_${cdcnt}"
1380 if [[ -z ${!var} ]] ; then
1381 eerror "You must either use just the CD_ROOT"
1382 eerror "or specify ALL the CD_ROOT_X variables."
1383 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1384 die "could not locate CD_ROOT_${cdcnt}"
1385 fi
1386 export CDROM_ROOTS_${cdcnt}="${!var}"
1387 done
1388 export CDROM_ROOT=${CDROM_ROOTS_1}
1389 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1390 return
1391 fi
1392
1393 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1394 einfon "This ebuild will need the "
1395 if [[ -z ${CDROM_NAME} ]] ; then
1396 echo "cdrom for ${PN}."
1397 else
1398 echo "${CDROM_NAME}."
1399 fi 1010 fi
1400 echo 1011 ) || die
1401 einfo "If you do not have the CD, but have the data files"
1402 einfo "mounted somewhere on your filesystem, just export"
1403 einfo "the variable CD_ROOT so that it points to the"
1404 einfo "directory containing the files."
1405 echo
1406 einfo "For example:"
1407 einfo "export CD_ROOT=/mnt/cdrom"
1408 echo
1409 else
1410 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1411 cdcnt=0
1412 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1413 cdcnt=$((cdcnt + 1))
1414 var="CDROM_NAME_${cdcnt}"
1415 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1416 done
1417 echo
1418 einfo "If you do not have the CDs, but have the data files"
1419 einfo "mounted somewhere on your filesystem, just export"
1420 einfo "the following variables so they point to the right place:"
1421 einfon ""
1422 cdcnt=0
1423 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1424 cdcnt=$((cdcnt + 1))
1425 echo -n " CD_ROOT_${cdcnt}"
1426 done
1427 echo
1428 einfo "Or, if you have all the files in the same place, or"
1429 einfo "you only have one cdrom, you can export CD_ROOT"
1430 einfo "and that place will be used as the same data source"
1431 einfo "for all the CDs."
1432 echo
1433 einfo "For example:"
1434 einfo "export CD_ROOT_1=/mnt/cdrom"
1435 echo
1436 fi
1437 export CDROM_CURRENT_CD=0
1438 cdrom_load_next_cd
1439} 1012}
1440 1013
1441# this is only used when you need access to more than one cd. 1014# @FUNCTION: doicon
1442# when you have finished using the first cd, just call this function. 1015# @USAGE: [options] <icons>
1443# when it returns, CDROM_ROOT will be pointing to the second cd. 1016# @DESCRIPTION:
1444# remember, you can only go forward in the cd chain, you can't go back. 1017# Install icon into the icon directory /usr/share/icons or into
1445cdrom_load_next_cd() { 1018# /usr/share/pixmaps if "--size" is not set.
1446 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1)) 1019# This is useful in conjunction with creating desktop/menu files.
1447 local var= 1020#
1448 1021# @CODE
1449 if [[ ! -z ${CD_ROOT} ]] ; then 1022# options:
1450 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}" 1023# -s, --size
1451 return 1024# !!! must specify to install into /usr/share/icons/... !!!
1452 fi 1025# size of the icon, like 48 or 48x48
1453 1026# supported icon sizes are:
1454 unset CDROM_ROOT 1027# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1455 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1028# -c, --context
1456 if [[ -z ${!var} ]] ; then 1029# defaults to "apps"
1457 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1030# -t, --theme
1458 cdrom_locate_file_on_cd ${!var} 1031# defaults to "hicolor"
1459 else 1032#
1460 export CDROM_ROOT=${!var} 1033# icons: list of icons
1461 fi 1034#
1462 1035# example 1: doicon foobar.png fuqbar.svg suckbar.png
1463 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1036# results in: insinto /usr/share/pixmaps
1037# doins foobar.png fuqbar.svg suckbar.png
1038#
1039# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1040# results in: insinto /usr/share/icons/hicolor/48x48/apps
1041# doins foobar.png fuqbar.png blobbar.png
1042# @CODE
1043doicon() {
1044 _iconins ${FUNCNAME} "$@"
1464} 1045}
1465 1046
1466# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd() 1047# @FUNCTION: newicon
1467# functions. this should *never* be called from an ebuild. 1048# @USAGE: [options] <icon> <newname>
1468# all it does is try to locate a give file on a cd ... if the cd isn't 1049# @DESCRIPTION:
1469# found, then a message asking for the user to insert the cdrom will be 1050# Like doicon, install the specified icon as newname.
1470# displayed and we'll hang out here until: 1051#
1471# (1) the file is found on a mounted cdrom 1052# @CODE
1472# (2) the user hits CTRL+C 1053# example 1: newicon foobar.png NEWNAME.png
1473cdrom_locate_file_on_cd() { 1054# results in: insinto /usr/share/pixmaps
1474 while [[ -z ${CDROM_ROOT} ]] ; do 1055# newins foobar.png NEWNAME.png
1475 local dir="$(dirname ${@})" 1056#
1476 local file="$(basename ${@})" 1057# example 2: newicon -s 48 foobar.png NEWNAME.png
1477 local mline="" 1058# results in: insinto /usr/share/icons/hicolor/48x48/apps
1478 local showedmsg=0 1059# newins foobar.png NEWNAME.png
1479 1060# @CODE
1480 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1061newicon() {
1481 [[ -d ${mline}/${dir} ]] || continue 1062 _iconins ${FUNCNAME} "$@"
1482 [[ ! -z $(find ${mline}/${dir} -iname ${file} -maxdepth 1) ]] \
1483 && export CDROM_ROOT=${mline}
1484 done
1485
1486 if [[ -z ${CDROM_ROOT} ]] ; then
1487 echo
1488 if [[ ${showedmsg} -eq 0 ]] ; then
1489 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1490 if [[ -z ${CDROM_NAME} ]] ; then
1491 einfo "Please insert the cdrom for ${PN} now !"
1492 else
1493 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1494 fi
1495 else
1496 if [[ -z ${CDROM_NAME_1} ]] ; then
1497 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1498 else
1499 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1500 einfo "Please insert+mount the ${!var} cdrom now !"
1501 fi
1502 fi
1503 showedmsg=1
1504 fi
1505 einfo "Press return to scan for the cd again"
1506 einfo "or hit CTRL+C to abort the emerge."
1507 read
1508 fi
1509 done
1510} 1063}
1511 1064
1065# @FUNCTION: strip-linguas
1066# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1067# @DESCRIPTION:
1512# Make sure that LINGUAS only contains languages that 1068# Make sure that LINGUAS only contains languages that
1513# a package can support 1069# a package can support. The first form allows you to
1514# 1070# specify a list of LINGUAS. The -i builds a list of po
1515# usage: strip-linguas <allow LINGUAS> 1071# files found in all the directories and uses the
1516# strip-linguas -i <directories of .po files> 1072# intersection of the lists. The -u builds a list of po
1517# strip-linguas -u <directories of .po files> 1073# files found in all the directories and uses the union
1518# 1074# of the lists.
1519# The first form allows you to specify a list of LINGUAS.
1520# The -i builds a list of po files found in all the
1521# directories and uses the intersection of the lists.
1522# The -u builds a list of po files found in all the
1523# directories and uses the union of the lists.
1524strip-linguas() { 1075strip-linguas() {
1525 local ls newls 1076 local ls newls nols
1526 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1077 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1527 local op=$1; shift 1078 local op=$1; shift
1528 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1079 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1529 local d f 1080 local d f
1530 for d in "$@" ; do 1081 for d in "$@" ; do
1531 if [[ ${op} == "-u" ]] ; then 1082 if [[ ${op} == "-u" ]] ; then
1532 newls=${ls} 1083 newls=${ls}
1533 else 1084 else
1534 newls="" 1085 newls=""
1535 fi 1086 fi
1536 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1087 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1537 if [[ ${op} == "-i" ]] ; then 1088 if [[ ${op} == "-i" ]] ; then
1538 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1089 has ${f} ${ls} && newls="${newls} ${f}"
1539 else 1090 else
1540 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1091 has ${f} ${ls} || newls="${newls} ${f}"
1541 fi 1092 fi
1542 done 1093 done
1543 ls=${newls} 1094 ls=${newls}
1544 done 1095 done
1545 ls=${ls//.po}
1546 else 1096 else
1547 ls=$@ 1097 ls="$@"
1548 fi 1098 fi
1549 1099
1550 ls=" ${ls} " 1100 nols=""
1551 newls="" 1101 newls=""
1552 for f in ${LINGUAS} ; do 1102 for f in ${LINGUAS} ; do
1553 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1103 if has ${f} ${ls} ; then
1554 newls="${newls} ${f}" 1104 newls="${newls} ${f}"
1555 else 1105 else
1556 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1106 nols="${nols} ${f}"
1557 fi 1107 fi
1558 done 1108 done
1559 if [[ -z ${newls} ]] ; then 1109 [[ -n ${nols} ]] \
1560 export LINGUAS="" 1110 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1561 else
1562 export LINGUAS=${newls:1} 1111 export LINGUAS=${newls:1}
1563 fi
1564} 1112}
1565 1113
1566# moved from kernel.eclass since they are generally useful outside of 1114# @FUNCTION: preserve_old_lib
1567# kernel.eclass -iggy (20041002) 1115# @USAGE: <libs to preserve> [more libs]
1568 1116# @DESCRIPTION:
1569# the following functions are useful in kernel module ebuilds, etc.
1570# for an example see ivtv or drbd ebuilds
1571
1572# set's ARCH to match what the kernel expects
1573set_arch_to_kernel() {
1574 i=10
1575 while ((i--)) ; do
1576 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1577 done
1578 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1579 case ${ARCH} in
1580 x86) export ARCH="i386";;
1581 amd64) export ARCH="x86_64";;
1582 hppa) export ARCH="parisc";;
1583 mips) export ARCH="mips";;
1584 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1585 *) export ARCH="${ARCH}";;
1586 esac
1587}
1588
1589# set's ARCH back to what portage expects
1590set_arch_to_portage() {
1591 i=10
1592 while ((i--)) ; do
1593 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1594 done
1595 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1596}
1597
1598# Jeremy Huddleston <eradicator@gentoo.org>:
1599# preserve_old_lib /path/to/libblah.so.0
1600# preserve_old_lib_notify /path/to/libblah.so.0
1601#
1602# These functions are useful when a lib in your package changes --soname. Such 1117# These functions are useful when a lib in your package changes ABI SONAME.
1603# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1118# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1604# would break packages that link against it. Most people get around this 1119# would break packages that link against it. Most people get around this
1605# by using the portage SLOT mechanism, but that is not always a relevant 1120# by using the portage SLOT mechanism, but that is not always a relevant
1606# solution, so instead you can add the following to your ebuilds: 1121# solution, so instead you can call this from pkg_preinst. See also the
1607# 1122# preserve_old_lib_notify function.
1608# src_install() {
1609# ...
1610# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1611# ...
1612# }
1613#
1614# pkg_postinst() {
1615# ...
1616# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1617# ...
1618# }
1619
1620preserve_old_lib() { 1123preserve_old_lib() {
1621 LIB=$1 1124 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1125 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1126 die "Invalid preserve_old_lib() usage"
1127 fi
1128 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1622 1129
1623 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1130 # let portage worry about it
1624 SONAME=`basename ${LIB}` 1131 has preserve-libs ${FEATURES} && return 0
1625 DIRNAME=`dirname ${LIB}`
1626 1132
1627 dodir ${DIRNAME} 1133 local lib dir
1628 cp ${ROOT}${LIB} ${D}${DIRNAME} 1134 for lib in "$@" ; do
1135 [[ -e ${ROOT}/${lib} ]] || continue
1136 dir=${lib%/*}
1137 dodir ${dir} || die "dodir ${dir} failed"
1138 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1629 touch ${D}${LIB} 1139 touch "${D}"/${lib}
1630 fi 1140 done
1631} 1141}
1632 1142
1143# @FUNCTION: preserve_old_lib_notify
1144# @USAGE: <libs to notify> [more libs]
1145# @DESCRIPTION:
1146# Spit helpful messages about the libraries preserved by preserve_old_lib.
1633preserve_old_lib_notify() { 1147preserve_old_lib_notify() {
1634 LIB=$1 1148 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1149 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1150 die "Invalid preserve_old_lib_notify() usage"
1151 fi
1635 1152
1636 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1153 # let portage worry about it
1637 SONAME=`basename ${LIB}` 1154 has preserve-libs ${FEATURES} && return 0
1638 1155
1156 local lib notice=0
1157 for lib in "$@" ; do
1158 [[ -e ${ROOT}/${lib} ]] || continue
1159 if [[ ${notice} -eq 0 ]] ; then
1160 notice=1
1639 einfo "An old version of an installed library was detected on your system." 1161 ewarn "Old versions of installed libraries were detected on your system."
1640 einfo "In order to avoid breaking packages that link against is, this older version" 1162 ewarn "In order to avoid breaking packages that depend on these old libs,"
1641 einfo "is not being removed. In order to make full use of this newer version," 1163 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1642 einfo "you will need to execute the following command:" 1164 ewarn "in order to remove these old dependencies. If you do not have this"
1643 einfo " revdep-rebuild --soname ${SONAME}" 1165 ewarn "helper program, simply emerge the 'gentoolkit' package."
1644 einfo 1166 ewarn
1645 einfo "After doing that, you can safely remove ${LIB}"
1646 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild"
1647 fi 1167 fi
1168 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1169 done
1648} 1170}
1649 1171
1650# Hack for people to figure out if a package was built with 1172# @FUNCTION: built_with_use
1651# certain USE flags 1173# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1174# @DESCRIPTION:
1652# 1175#
1653# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1176# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1654# ex: built_with_use xchat gtk2
1655# 1177#
1656# Flags: -a all USE flags should be utilized 1178# A temporary hack until portage properly supports DEPENDing on USE
1657# -o at least one USE flag should be utilized 1179# flags being enabled in packages. This will check to see if the specified
1658# Note: the default flag is '-a' 1180# DEPEND atom was built with the specified list of USE flags. The
1181# --missing option controls the behavior if called on a package that does
1182# not actually support the defined USE flags (aka listed in IUSE).
1183# The default is to abort (call die). The -a and -o flags control
1184# the requirements of the USE flags. They correspond to "and" and "or"
1185# logic. So the -a flag means all listed USE flags must be enabled
1186# while the -o flag means at least one of the listed IUSE flags must be
1187# enabled. The --hidden option is really for internal use only as it
1188# means the USE flag we're checking is hidden expanded, so it won't be found
1189# in IUSE like normal USE flags.
1190#
1191# Remember that this function isn't terribly intelligent so order of optional
1192# flags matter.
1659built_with_use() { 1193built_with_use() {
1194 local hidden="no"
1195 if [[ $1 == "--hidden" ]] ; then
1196 hidden="yes"
1197 shift
1198 fi
1199
1200 local missing_action="die"
1201 if [[ $1 == "--missing" ]] ; then
1202 missing_action=$2
1203 shift ; shift
1204 case ${missing_action} in
1205 true|false|die) ;;
1206 *) die "unknown action '${missing_action}'";;
1207 esac
1208 fi
1209
1660 local opt=$1 1210 local opt=$1
1661 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1211 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1662 1212
1663 local PKG=$(best_version $1) 1213 local PKG=$(best_version $1)
1214 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1664 shift 1215 shift
1665 1216
1666 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1217 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1667 [[ ! -e ${USEFILE} ]] && return 1 1218 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1219
1220 # if the IUSE file doesn't exist, the read will error out, we need to handle
1221 # this gracefully
1222 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1223 case ${missing_action} in
1224 true) return 0;;
1225 false) return 1;;
1226 die) die "Unable to determine what USE flags $PKG was built with";;
1227 esac
1228 fi
1229
1230 if [[ ${hidden} == "no" ]] ; then
1231 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1232 # Don't check USE_EXPAND #147237
1233 local expand
1234 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1235 if [[ $1 == ${expand}_* ]] ; then
1236 expand=""
1237 break
1238 fi
1239 done
1240 if [[ -n ${expand} ]] ; then
1241 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1242 case ${missing_action} in
1243 true) return 0;;
1244 false) return 1;;
1245 die) die "$PKG does not actually support the $1 USE flag!";;
1246 esac
1247 fi
1248 fi
1249 fi
1668 1250
1669 local USE_BUILT=$(<${USEFILE}) 1251 local USE_BUILT=$(<${USEFILE})
1670 while [[ $# -gt 0 ]] ; do 1252 while [[ $# -gt 0 ]] ; do
1671 if [[ ${opt} = "-o" ]] ; then 1253 if [[ ${opt} = "-o" ]] ; then
1672 has $1 ${USE_BUILT} && return 0 1254 has $1 ${USE_BUILT} && return 0
1676 shift 1258 shift
1677 done 1259 done
1678 [[ ${opt} = "-a" ]] 1260 [[ ${opt} = "-a" ]]
1679} 1261}
1680 1262
1263# @FUNCTION: epunt_cxx
1264# @USAGE: [dir to scan]
1265# @DESCRIPTION:
1681# Many configure scripts wrongly bail when a C++ compiler 1266# Many configure scripts wrongly bail when a C++ compiler could not be
1682# could not be detected. #73450 1267# detected. If dir is not specified, then it defaults to ${S}.
1268#
1269# http://bugs.gentoo.org/73450
1683epunt_cxx() { 1270epunt_cxx() {
1684 local dir=$1 1271 local dir=$1
1685 [[ -z ${dir} ]] && dir=${S} 1272 [[ -z ${dir} ]] && dir=${S}
1686 ebegin "Removing useless C++ checks" 1273 ebegin "Removing useless C++ checks"
1687 local f 1274 local f
1688 for f in $(find ${dir} -name configure) ; do 1275 find "${dir}" -name configure | while read f ; do
1689 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1276 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1690 done 1277 done
1691 eend 0 1278 eend 0
1692} 1279}
1693 1280
1694# dopamd <file> [more files] 1281# @FUNCTION: make_wrapper
1695# 1282# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1696# Install pam auth config file in /etc/pam.d 1283# @DESCRIPTION:
1697dopamd() { 1284# Create a shell wrapper script named wrapper in installpath
1698 [[ -z $1 ]] && die "dopamd requires at least one argument" 1285# (defaults to the bindir) to execute target (default of wrapper) by
1699 1286# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1700 use pam || return 0 1287# libpaths followed by optionally changing directory to chdir.
1701
1702 insinto /etc/pam.d
1703 doins "$@" || die "failed to install $@"
1704}
1705# newpamd <old name> <new name>
1706#
1707# Install pam file <old name> as <new name> in /etc/pam.d
1708newpamd() {
1709 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1710
1711 use pam || return 0
1712
1713 insinto /etc/pam.d
1714 newins "$1" "$2" || die "failed to install $1 as $2"
1715}
1716
1717# make a wrapper script ...
1718# NOTE: this was originally games_make_wrapper, but I noticed other places where
1719# this could be used, so I have moved it here and made it not games-specific
1720# -- wolf31o2
1721# $1 == wrapper name
1722# $2 == binary to run
1723# $3 == directory to chdir before running binary
1724# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1725# $5 == path for wrapper
1726make_wrapper() { 1288make_wrapper() {
1727 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1289 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1728 local tmpwrapper=$(emktemp) 1290 local tmpwrapper=$(emktemp)
1291 # We don't want to quote ${bin} so that people can pass complex
1292 # things as $bin ... "./someprog --args"
1729 cat << EOF > "${tmpwrapper}" 1293 cat << EOF > "${tmpwrapper}"
1730#!/bin/sh 1294#!/bin/sh
1731cd "${chdir}" 1295cd "${chdir:-.}"
1296if [ -n "${libdir}" ] ; then
1297 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1732export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1298 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1299 else
1300 export LD_LIBRARY_PATH="${libdir}"
1301 fi
1302fi
1733exec ${bin} "\$@" 1303exec ${bin} "\$@"
1734EOF 1304EOF
1735 chmod go+rx "${tmpwrapper}" 1305 chmod go+rx "${tmpwrapper}"
1736 if [ -n "${5}" ] 1306 if [[ -n ${path} ]] ; then
1737 then 1307 (
1738 exeinto ${5} 1308 exeinto "${path}"
1739 newexe "${tmpwrapper}" "${wrapper}" 1309 newexe "${tmpwrapper}" "${wrapper}"
1310 ) || die
1740 else 1311 else
1741 newbin "${tmpwrapper}" "${wrapper}" 1312 newbin "${tmpwrapper}" "${wrapper}" || die
1313 fi
1314}
1315
1316# @FUNCTION: path_exists
1317# @USAGE: [-a|-o] <paths>
1318# @DESCRIPTION:
1319# Check if the specified paths exist. Works for all types of paths
1320# (files/dirs/etc...). The -a and -o flags control the requirements
1321# of the paths. They correspond to "and" and "or" logic. So the -a
1322# flag means all the paths must exist while the -o flag means at least
1323# one of the paths must exist. The default behavior is "and". If no
1324# paths are specified, then the return value is "false".
1325path_exists() {
1326 local opt=$1
1327 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1328
1329 # no paths -> return false
1330 # same behavior as: [[ -e "" ]]
1331 [[ $# -eq 0 ]] && return 1
1332
1333 local p r=0
1334 for p in "$@" ; do
1335 [[ -e ${p} ]]
1336 : $(( r += $? ))
1337 done
1338
1339 case ${opt} in
1340 -a) return $(( r != 0 )) ;;
1341 -o) return $(( r == $# )) ;;
1342 esac
1343}
1344
1345# @FUNCTION: in_iuse
1346# @USAGE: <flag>
1347# @DESCRIPTION:
1348# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1349# as necessary.
1350#
1351# Note that this function should not be used in the global scope.
1352in_iuse() {
1353 debug-print-function ${FUNCNAME} "${@}"
1354 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1355
1356 local flag=${1}
1357 local liuse=( ${IUSE} )
1358
1359 has "${flag}" "${liuse[@]#[+-]}"
1360}
1361
1362# @FUNCTION: use_if_iuse
1363# @USAGE: <flag>
1364# @DESCRIPTION:
1365# Return true if the given flag is in USE and IUSE.
1366#
1367# Note that this function should not be used in the global scope.
1368use_if_iuse() {
1369 in_iuse $1 || return 1
1370 use $1
1371}
1372
1373# @FUNCTION: usex
1374# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1375# @DESCRIPTION:
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1379
1380# @FUNCTION: prune_libtool_files
1381# @USAGE: [--all]
1382# @DESCRIPTION:
1383# Locate unnecessary libtool files (.la) and libtool static archives
1384# (.a) and remove them from installation image.
1385#
1386# By default, .la files are removed whenever the static linkage can
1387# either be performed using pkg-config or doesn't introduce additional
1388# flags.
1389#
1390# If '--all' argument is passed, all .la files are removed. This is
1391# usually useful when the package installs plugins and does not use .la
1392# files for loading them.
1393#
1394# The .a files are only removed whenever corresponding .la files state
1395# that they should not be linked to, i.e. whenever these files
1396# correspond to plugins.
1397#
1398# Note: if your package installs any .pc files, this function implicitly
1399# calls pkg-config. You should add it to your DEPEND in that case.
1400prune_libtool_files() {
1401 debug-print-function ${FUNCNAME} "$@"
1402
1403 local removing_all opt
1404 for opt; do
1405 case "${opt}" in
1406 --all)
1407 removing_all=1
1408 ;;
1409 *)
1410 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1411 esac
1412 done
1413
1414 # Create a list of all .pc-covered libs.
1415 local pc_libs=()
1416 if [[ ! ${removing_all} ]]; then
1417 local f
1418 local tf=${T}/prune-lt-files.pc
1419 local pkgconf=$(tc-getPKG_CONFIG)
1420
1421 while IFS= read -r -d '' f; do # for all .pc files
1422 local arg
1423
1424 sed -e '/^Requires:/d' "${f}" > "${tf}"
1425 for arg in $("${pkgconf}" --libs "${tf}"); do
1426 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1427 done
1428 done < <(find "${D}" -type f -name '*.pc' -print0)
1429
1430 rm -f "${tf}"
1431 fi
1432
1433 local f
1434 while IFS= read -r -d '' f; do # for all .la files
1435 local archivefile=${f/%.la/.a}
1436
1437 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1438
1439 # Remove static libs we're not supposed to link against.
1440 if grep -q '^shouldnotlink=yes$' "${f}"; then
1441 if [[ -f ${archivefile} ]]; then
1442 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1443 rm -f "${archivefile}"
1444 fi
1445
1446 # The .la file may be used by a module loader, so avoid removing it
1447 # unless explicitly requested.
1448 [[ ${removing_all} ]] || continue
1742 fi 1449 fi
1450
1451 # Remove .la files when:
1452 # - user explicitly wants us to remove all .la files,
1453 # - respective static archive doesn't exist,
1454 # - they are covered by a .pc file already,
1455 # - they don't provide any new information (no libs & no flags).
1456 local reason
1457 if [[ ${removing_all} ]]; then
1458 reason='requested'
1459 elif [[ ! -f ${archivefile} ]]; then
1460 reason='no static archive'
1461 elif has "${f##*/}" "${pc_libs[@]}"; then
1462 reason='covered by .pc'
1463 elif [[ ! $(sed -nre \
1464 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1465 "${f}") ]]; then
1466 reason='no libs & flags'
1467 fi
1468
1469 if [[ ${reason} ]]; then
1470 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1471 rm -f "${f}"
1472 fi
1473 done < <(find "${D}" -type f -name '*.la' -print0)
1743} 1474}
1475
1476check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1477
1478fi

Legend:
Removed from v.1.166  
changed lines
  Added in v.1.401

  ViewVC Help
Powered by ViewVC 1.1.20